/*
  +----------------------------------------------------------------------+
  | MDCacheD client library                                              |
  +----------------------------------------------------------------------+
  | Copyright (c) 2008-2011 Ivan Voras                                        |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Ivan Voras                                                   |
  +----------------------------------------------------------------------+
*/

/* $Id: php_mdcached.h 443 2012-03-06 23:23:48Z ivoras $ */

#ifndef PHP_MDCACHED_H
#define PHP_MDCACHED_H

extern zend_module_entry mdcached_module_entry;
#define phpext_mdcached_ptr &mdcached_module_entry

#ifdef PHP_WIN32
#define PHP_MDCACHED_API __declspec(dllexport)
#else
#define PHP_MDCACHED_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(mdcached);
PHP_MSHUTDOWN_FUNCTION(mdcached);
PHP_RINIT_FUNCTION(mdcached);
PHP_RSHUTDOWN_FUNCTION(mdcached);
PHP_MINFO_FUNCTION(mdcached);

PHP_FUNCTION(mc_connect_tcp);
PHP_FUNCTION(mc_connect_local);
PHP_FUNCTION(mc_result_to_string);
PHP_FUNCTION(mc_close_connection);
PHP_FUNCTION(mc_perform_handshake);
PHP_FUNCTION(mc_put_simple);
PHP_FUNCTION(mc_get_simple);
PHP_FUNCTION(mc_del_simple);
PHP_FUNCTION(mc_put_simple_tags);
PHP_FUNCTION(mc_get_simple_tags);
PHP_FUNCTION(mc_get_by_tag_values);
PHP_FUNCTION(mc_del_by_tag_values);
PHP_FUNCTION(mc_get_all_keys);
PHP_FUNCTION(mc_atomic_cmpset);
PHP_FUNCTION(mc_atomic_add);
PHP_FUNCTION(mc_atomic_fetchadd);
PHP_FUNCTION(mc_atomic_readandclear);
PHP_FUNCTION(mc_atomic_put);
PHP_FUNCTION(mc_atomic_get);
PHP_FUNCTION(mc_mput);
PHP_FUNCTION(mc_mget);
PHP_FUNCTION(mc_mdel);
PHP_FUNCTION(mc_tstack_push);
PHP_FUNCTION(mc_tstack_pop);
PHP_FUNCTION(mc_set_tags);


/* 
  	Declare any global variables you may need between the BEGIN
	and END macros here:     

ZEND_BEGIN_MODULE_GLOBALS(mdcached)
	long  global_value;
	char *global_string;
ZEND_END_MODULE_GLOBALS(mdcached)
*/

/* In every utility function you add that needs to use variables 
   in php_mdcached_globals, call TSRMLS_FETCH(); after declaring other 
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as MDCACHED_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define MDCACHED_G(v) TSRMG(mdcached_globals_id, zend_mdcached_globals *, v)
#else
#define MDCACHED_G(v) (mdcached_globals.v)
#endif

#endif	/* PHP_MDCACHED_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
